let tgapi = require("node-telegram-bot-api");
let EventEmitter = require("events").EventEmitter;
let util = require("util");

class tg {
  constructor(options) {
    EventEmitter.call(this);
    this.options = options || {};
    this.token = options.token || null;
    this.options.polling = options.polling || true;
    this.client = new tgapi(this.options.token, this.options);

    this.client.on("message", msg => {
      if (msg.date >= (~~(Date.now() / 1000) - 10)) {
        try {
          msg.text = msg.text && msg.text.match(/^\//g) ? msg.text.replace(/^\//g, ".") : msg.text;
          this.emit("data", ["message", this.reply(msg)]);
        }
        catch(err) {
          console.log(err);
        }
      }
    });
  }
  send(id, msg) {
    this.client.sendMessage(id, msg);
  }
  reply(tmp) {
    return {
      type: "tg",
      network: "Telegram",
      channel: tmp.chat.title,
      channelid: tmp.chat.id,
      user: {
        nick: tmp.from.first_name,
        username: tmp.from.username,
        hostname: tmp.from.id
      },
      message: tmp.text,
      time: tmp.date,
      raw: tmp,
      reply: msg => {
        this.send(tmp.chat.id, msg);
      },
      replyAction: msg => {
        this.send(tmp.chat.id, `Uwe ${msg}`);
      },
      replyNotice: msg => {
        this.send(tmp.chat.id, msg);
      }
    };
  }
}

module.exports = tg;
util.inherits(tg, EventEmitter);